<template>
	<div :id="id" :class="$style.block">
		<h2 v-if="heading" :class="$style.heading">{{ heading }}</h2>
		<ul :class="$style.images">
			<li v-for="(image, index) in images" :key="index" :class="$style.image">
				<figure :class="$style.imageInner">
					<BaseImage
						:image="image.image"
						:class="$style.baseImage"
						:aspect="1"
						contain
						compression-level="high"
						sizes="(min-width: 1024px) 126px, (min-width: 768px) calc((100vw - 190px) / 6), calc((100vw - 140px) / 3)"
					/>
					<figcaption :class="$style.imageCaption">
						<div>{{ getLabel(image.label || image.labelMobile || (image.image && image.image.alt)) }}</div>
						<div
							v-if="getLabel(image.label || image.labelMobile || (image.image && image.image.alt), true)"
							:class="$style.isSmall"
							>{{ getLabel(image.label || image.labelMobile || (image.image && image.image.alt), true) }}</div
						>
					</figcaption>
				</figure>
			</li>
		</ul>
		<div v-if="$hasRichText(description)" v-rich-content :class="$style.description" v-html="description"></div>
	</div>
</template>

<script>
export default {
	props: {
		id: {
			type: String,
			default: null,
		},

		critical: {
			type: Boolean,
			default: false,
		},

		heading: {
			type: String,
			default: '',
		},

		description: {
			type: [String, Array],
			default: '',
		},

		images: {
			type: Array,
			default: () => [],
		},
	},

	methods: {
		getLabel: (label, isSmall) => {
			const labelParts = label.split('\n');
			return !isSmall ? (labelParts[0] || '').trim() : labelParts.slice(1).join('\n');
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	max-width: 129rem + size('l') * 2;
	padding: size('m+');
	margin: 0 auto;

	@include above('large') {
		padding: 9rem 6.3rem 9.4rem;
	}
}

.heading {
	@include use-text-style('heading-400');

	margin-bottom: 5.3rem;
	font-family: font-family('secondary');
	font-weight: 300;
	text-align: center;
	white-space: pre-line;
}

.images {
	display: flex;
	flex-wrap: wrap;
	margin: 0 size('xs') * -1 size('s') * -1;
	list-style: none;

	@include above('medium') {
		display: grid;
		grid-template-columns: repeat(8, 1fr);
		gap: 5rem 0;
		max-width: 116rem;
		margin: 0 auto;
	}
}

.image {
	flex: 0 0 auto;
	width: (100% / 3);
	padding: 0 size('xs') size('s');

	@include above('medium') {
		grid-column: span 2;
		width: auto;
		padding: 0 size('xs');

		&:nth-child(7n + 1) {
			grid-column: 2 / span 2;
		}
	}
}

.imageInner .baseImage {
	@include above('medium') {
		width: 12.6rem;
		margin: auto;
	}
}

.imageCaption {
	@include font-family('secondary');
	@include use-text-style('type-400');

	margin-top: size('base');
	line-height: 1.5;
	text-align: center;
	white-space: pre-line;

	@include above('medium') {
		@include use-text-style('heading-100');

		.isSmall {
			margin-top: 0.6rem;
			line-height: 1.4;

			@include use-text-style('type-100');
		}
	}
}

.description {
	@include use-text-style('type-500');

	margin-top: 5rem;
	font-weight: 300;
	text-align: center;

	p {
		&:not(:last-child) {
			margin-bottom: 1em;
		}
	}

	a {
		text-decoration: underline;
	}
}
</style>
